using System;
using ccc4;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace WindowsGame1
{

    // ========================================================================
	public class Boid{Model
	{
		private Matrix m_Pʍs = Matrix.Identity;  // fPʍs
		private Vector3 m_pos = Vector3.Zero;     // fʒu

		int m_Pʍs񐳋KJE^ = 0;

		// ANZT ----------------------------------------------------------------------
		// Pʍs
		public Matrix Pʍs
		{
			get { return m_Pʍs; }
			set { m_Pʍs = value; }
		}
		/*
		Matrix M11 - M44
		11 12 13 14 -X
		21 22 23 24 -Y
		31 32 33 34 -Z
		41 42 43 44
		*/

		// w肷邱ƂɂAs^C~O炷(1t[ɑSunit̏sƂ)B
		public int Pʍs񐳋KJE^
		{
			set { m_Pʍs񐳋KJE^ = value; }
		}

		// ʒuW
		public Vector3 pos
		{
			get { return m_pos; }
			set { m_pos = value; }
		}

		public Boid{Model()
		{
			m_Pʍs = Matrix.Identity;  // fPʍs
			m_pos = Vector3.Zero;     // fʒu
		}

		// ====================================================================
		// sb`(x̉])
		// d:]p(WA)
		public void RotateX_Pitch(float d)
		{
			if (0f == d)
			{
				return;
			}

			m_Pʍs *= Matrix.CreateFromAxisAngle(m_Pʍs.Right, d);

			Pʍs񐳋K();   // Ԋuunit̒Pʍs̐K
		}


		// [(ỷ])
		public void RotateY_Yaw(float d)
		{
			if (0f == d)
			{
				return;
			}

			m_Pʍs *= Matrix.CreateFromAxisAngle(m_Pʍs.Up, d);

			Pʍs񐳋K();   // Ԋuunit̒Pʍs̐K
		}


		// [(z̉])
		public void RotateZ_Roll(float d)
		{
			if (0f == d)
			{
				return;
			}

			m_Pʍs *= Matrix.CreateFromAxisAngle(m_Pʍs.Backward, d);

			Pʍs񐳋K();   // Ԋuunit̒Pʍs̐K
		}


		public void RotateYawPitchRoll_YXZ_M(float Yaw, float Pitch, float Roll)
		{
			// ̌vZŔCӎ̉]\
			m_Pʍs = Matrix.CreateFromYawPitchRoll(Yaw, Pitch, Roll) * m_Pʍs;
		}


		/// <summary>
		/// Ԋuunit̒Pʍs̐K
		/// </summary>
		public void Pʍs񐳋K()
		{
			m_Pʍs񐳋KJE^++;

			if (2048 < m_Pʍs񐳋KJE^)
			{
				float angX, angY, angZ;

				Matrix wkM, wkMA;

				wkM = this.Pʍs;

				// AbsX > AbsZ:zpx狁߂B
				// AbsX < AbsZ:xpx狁߂B

				if (Math.Abs(this.Pʍs.Up.X) < Math.Abs(this.Pʍs.Up.Z))
				{
					// --------------------------------------------------------------------------------
					angX = (float)Math.Atan2(this.Pʍs.Up.Z, this.Pʍs.Up.Y);
					wkM *= Matrix.CreateRotationX(-angX);   // x ]

					// --------------------------------------------------------------------------------
					angZ = (float)Math.Atan2(wkM.Up.X, wkM.Up.Y);
					wkM *= Matrix.CreateRotationZ(angZ);    // z ]

					// --------------------------------------------------------------------------------
					angY = (float)Math.Atan2(wkM.Backward.X, wkM.Backward.Z);

					// VPʍs
					wkMA = Matrix.CreateRotationY(angY);
					wkMA *= Matrix.CreateRotationZ(-angZ);
					wkMA *= Matrix.CreateRotationX(angX);
				}
				else
				{
					// --------------------------------------------------------------------------------
					angZ = (float)Math.Atan2(this.Pʍs.Up.X, this.Pʍs.Up.Y);
					wkM *= Matrix.CreateRotationZ(angZ);   // z ]

					// --------------------------------------------------------------------------------
					angX = (float)Math.Atan2(wkM.Up.Z, wkM.Up.Y);
					wkM *= Matrix.CreateRotationX(-angX);    // x ]

					// --------------------------------------------------------------------------------
					angY = (float)Math.Atan2(wkM.Backward.X, wkM.Backward.Z);

					// VPʍs
					wkMA = Matrix.CreateRotationY(angY);
					wkMA *= Matrix.CreateRotationX(angX);
					wkMA *= Matrix.CreateRotationZ(-angZ);
				}

				this.Pʍs = wkMA;

				m_Pʍs񐳋KJE^ = 0;
			}
		}


		// --------------------------------------
		// Boids }EXNbNp
		private BoundingSphere m_BoundingSphereA = new BoundingSphere(Vector3.Zero, 2f);

		[System.Xml.Serialization.XmlIgnoreAttribute]
		public float BoundingSphereAa
		{
			set { m_BoundingSphereA.Radius = value; }
		}


		/// <summary>
		/// }EXI[o[,sbN̔
		/// ߂l : =null / ܂ł̋=L
		/// BoundingBoxOĐݒ肷B
		/// </summary>
		/// <param name="graphics"></param>
		/// <param name="view"></param>
		/// <param name="proj"></param>
		/// <param name="mouseX"></param>
		/// <param name="mouseY"></param>
		/// <returns></returns>
		virtual public float? sbNSphere(Ray pickRay)
		{
			this.m_BoundingSphereA.Center = this.pos;

			Nullable<float> result = pickRay.Intersects(this.m_BoundingSphereA);

			return result;  // L̏ꍇ:܂ł̋
		}

	}



	// ========================================================================
	public class BoidModel : Boid{Model
	{
		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public O2 m_O = new O2();

		// ==============================================
		// ȉunit\l

		// }`Xbhp XbhŌ肵unit̍sꎞۑ
		private Matrix m_newPʍs = Matrix.Identity;  // fPʍs

		private Vector3 m_new_pos = Vector3.Zero;     // fʒu
		private float m_newx = 0;

		// {Ch(Boids)pp[^ unitɐݒ 

		// Œ荀 ===
		// bsE傫1̉ɁAƏȃO[vɕB100ƍו͂Ȃ

		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO -> ݒΏۂƂ?
		public BoundingSphere Boids_bsE = new BoundingSphere(Vector3.Zero, 48f);  // uniť͈(Œl) W:48


		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public BoundingSphere Boids_bs펋E = new BoundingSphere(Vector3.Zero, 1f);  // 鑤unitBoundingSphere


		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public bool bՓ = false;	// ̃{ChƏՓ˂ꍇAtrue

		// iɂύ ===

		public int Boids = 0;		// :iɃRs[ꂽŉZ

		public float Boidsʎp = 0;	// ͈͂̊px 135 (ΏۂƂ͈)
		public float Boidslen = 0;	// ΏۂƂȂ鋗 W:16

		public float Boidslen = 0;	// ΏۂƂȂ鋗(len 琮len͈̔͂ł͑xAŋunitɍ킹)

		// eLXg\p JE^
		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public int Boids_i = 0;
		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public int Boids_i = 0;
		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public int Boids_i = 0;


		// ----------------------------------------------
		// 1t[ɉ]\Ȋpx
		private float m_\pxrad = 0;    // unit]\px(rad)

		// ----------------------------------------------
		private float m_ōx = 0;
		// iɂύ ===

		// 1t[Ɉړ\ȋ(_̑x)
		private float m_x = 0;

		private float m_Œᑬx = 0;    // ōx50%(~͂Ȃ)

		private float m_x = 0;  // ōx0.5%
		private float m_x = 0;  // ōx1%


		// len : ƂP̉ɂȂB
		// P̉:2,12
		// :16

		// Wv ===
		public int Boids_ = 0;   // `[̃jbgƂ͈͓̋Ɠ_ƂȂ
		public int Boids_ = 0;   // ̃jbgƏՓ˔sAՓ˂ꍇ͌_ 

		public int m_HPmax = 0;    // qbg|Cg ől 
		public int m_HP = 0;       // qbg|Cg 0Ōj 


		private Boids m_Boids^Cv = Boids.r;

		public enum Boids
		{
			r,
			T,
			
		};

		// -------------------------------

		public Boids Boids^Cv
		{
			get { return m_Boids^Cv; }
			set { this.m_Boids^Cv = value; }
		}


		/// <summary>
		/// }`Xbhp XVeۂ̃f[^ɔf
		/// </summary>
		public void Copy_Update()
		{
			this.Pʍs = this.m_newPʍs;
			this.pos = this.m_new_pos;
			this.m_x = this.m_newx;

			this.m_O.Copy_Update();
		}

		/// <summary>
		/// }`Xbhp XVeۂ̃f[^ŏ
		/// </summary>
		public void Copy_Init()
		{
			this.m_newPʍs = this.Pʍs;
			this.m_new_pos = this.pos;
			this.m_newx = this.m_x;
		}


		// ANZT ----------------------------------------------------------------------
		public float x       // _̑x
		{
			get { return this.m_x; }
			set { this.m_x = value; }
		}

		public float ōx
		{
			get { return this.m_ōx; }
			set { this.m_ōx = value; }
		}

		public float Œᑬx
		{
			get { return this.m_Œᑬx; }
			set { this.m_Œᑬx = value; }
		}

		public float \pxrad
		{
			get { return this.m_\pxrad; }
			set { this.m_\pxrad = value; }
		}


		[System.Xml.Serialization.XmlIgnoreAttribute] // VAO
		public int HP
		{
			get { return m_HP; }
			set { m_HP = value; }
		}

		// --------------------------------------
		public BoidModel()
		{
		}

		public void OInitialize(GraphicsDeviceManager graphics, Color OՃJ[, Color wiF)
		{
			this.m_O.Initialize(graphics, OՃJ[, wiF);
		}

		/// <summary>
		/// OՔz݂unitWŏ
		/// </summary>
		public void Opos()
		{
			this.m_O.pos(this.pos);
		}


		//	ړ Quaternion 
		// }`Xbhp XVeƃGAɕۑ
		public void T_iQ(float ړ, int GameCount)
		{
			this.m_new_pos = this.pos + (this.m_newPʍs.Backward * ړ);
			this.m_O.ݒ(this.pos, GameCount);
		}


		public void x()
		{
			this.m_x = this.m_Œᑬx;
		}


		// =========================================================================================
		// =========================================================================================
		// ڕWWɌāACӎ̉]+iړ
		// }`Xbhp XVeƃGAɕۑ
		// XVe : Pʍs, x, pos
		public void T_MovePosQ(Vector3 ڕW, float fx, int GameCount)
		{
			// ڕW = ݂̎pos݂W
			Vector3 pos = ڕW - this.pos;

			T_Move(pos, fx, GameCount);
		}


		// =========================================================================================
		// wBCӎ̉]+iړ
		// }`Xbhp XVeƃGAɕۑ
		// XVe : Pʍs, x, pos
		// T_MovePosQ()ɏ\bh
		// ڕWthis.Pʍs.Backward w肷邱Ƃɂ蒼iB
		// float fx:w̑xɕωB-1̏ꍇxωB
		public void T_MoveV3(Vector3 ڕW, float fx, int GameCount)
		{
			// ڕW = jbgڎw
			Vector3 pos = ڕW;
			T_Move(pos, fx, GameCount);
		}


		// unit̉]ƒi(̃̕\bhĂ΂)
		private void T_Move(Vector3 pos, float fx, int GameCount)
		{
			// fx:w̑xɕωB-1̏ꍇxωB
			if (-1f != fx)
			{
				if (fx > this.m_x)
				{
					// 
					this.m_newx = this.m_x + this.m_x;

                    if (this.m_newx > this.m_ōx)
					{
						this.m_newx = this.m_ōx;
					}
				}
				else if (fx < this.m_x)
				{
					// 
					this.m_newx = this.m_x - this.m_x;

                    if (this.m_newx < this.m_Œᑬx)
					{
						this.m_newx = this.m_Œᑬx;
					}
				}
			}


			float ]p = this.m_\pxrad;  // 1t[ɉ]\Ȋpx

			// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11

			// isƈړڕW烆jbg̉]߂B
			Vector3 ] = Vector3.Cross(this.Pʍs.Backward, pos);    // 2̃xNg̊O 
			// 2̃xNg̊O = 2̃xNgɑ΂ĐȕA2̃xNgł镽slӌ`ƓxNg
			// pos0̏ꍇA]0

			// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11

			pos.Normalize();
			float vDot = Vector3.Dot(this.Pʍs.Backward, pos);  // Kꂽ2̃xNg̓:  ̏ꍇ2̃xNg͔ΕĂB

			if (vDot > 1f) vDot = 1f;   // !!!
			if (vDot < -1f) vDot = -1f;   // !!!

			// px unit猩pxBO:0/ :180/ ^:90
			// px unit猩pxBO:0rad / :PI rad / ^: PI / 2 rad
			float ڕWp = (float)Math.Acos(vDot);      // Acos : -1`1 / isڕW܂ł̊px

			// --------------------------------------------------------------------------

			// ]pڕW܂ł̊px傫ꍇA]p}B
			if (]p > ڕWp)
			{
				]p = ڕWp;
			}

			// --------------------------------------------------------------------------

			// ڕW^ʂɂꍇA^ɂꍇ
			if (Vector3.Zero == ])
			{
				] = new Vector3(1, 0, 0);

				if (vDot > 0)  // ς̏ꍇAĂB
				{
					// ڕW^ʂɂꍇ
					]p = 0; // ]ȂB
				}
			}
			else
			{
				].Normalize();
			}

			this.Pʍs񐳋K();  // AAA

			this.m_newPʍs = this.Pʍs * Matrix.CreateFromAxisAngle(], ]p); // Pʍs XV(Bꂱł̂)

			// -----------------------------------
			// iړ (OՐݒp)
			this.T_iQ(this.m_newx, GameCount);		// Oi

			/*
						// -----------------------------------
						// debug
						dpos = pos;
						d] = ];

						d]p = ]p;
						d]p = ڕWp;
			*/
		}


		public void T_ʊp(Vector3 pos, out float ʊp)
		{
			// pos = ݂̎pos猩AW

			// T_MovePosQ()ɏ\bh
			// ----
			// ʊp:is瑼unitɌĂ̔Cӎ̊px
			//        is0^180()
			if (pos == Vector3.Zero)
			{
				// ϕ0̏ꍇAωB
				pos = this.Pʍs.Backward;
			}

			pos.Normalize();    //  pos0̏ꍇAʊp=NaN

			float vDot = Vector3.Dot(this.Pʍs.Backward, pos);  // Kꂽ2̃xNg̓:  ̏ꍇ2̃xNg͔ΕĂB

			if (vDot > 1f) vDot = 1f;
			if (vDot < -1f) vDot = -1f;

			// px unit猩pxBO:0/ :180/ ^:90
			// px unit猩pxBO:0rad / :PI rad / ^: PI / 2 rad
			ʊp = (float)Math.Acos(vDot);      // Acos(-1`1) / isڕW܂ł̊px
		}


		public void T_͊p(Vector3 pos, out float ͊p, out float abs͊p)
		{
			// pos = ݂̎pos猩AW

			// T_MovePosQ()ɏ\bh
			// ----
			// ͊p:isƂpx(L)
			//    Up
			//     0 
			// -90 + 90
			//    180

			if (pos == Vector3.Zero)
			{
				// ϕ0̏ꍇAωB
				pos = this.Pʍs.Backward;
			}
			pos.Normalize();    //  pos0̏ꍇAʊp=NaN

			// isƈړڕW烆jbg̉]߂B
			Vector3 ] = Vector3.Cross(this.Pʍs.Backward, pos);    // 2̃xNg̊O 
			].Normalize();
			// 2̃xNg̊O = 2̃xNgɑ΂ĐȕA2̃xNgł镽slӌ`ƓxNg

			float vDot = Vector3.Dot(this.Pʍs.Left, ]);  // Kꂽ2̃xNg̓:  ̏ꍇ2̃xNg͔ΕĂB

			if (vDot > 1f) vDot = 1f;
			if (vDot < -1f) vDot = -1f;

			͊p = (float)Math.Acos(vDot);      // isڕW܂ł̊px
			abs͊p = ͊p;

			/*
			 * ς2̃xNg̊px߂ꍇAꂪvX40xȂ̂}CiX40xȂ̂
			 * ʂȂA2̃xNg̊OςƂāAƎxNg̓ςƂāA̐Δʂł܂B
			 */
			Vector3 vCross = Vector3.Cross(this.Pʍs.Left, ]);    // 2̃xNg̊O 
			vCross.Normalize();

			float vDot2 = Vector3.Dot(this.Pʍs.Forward, vCross);   // Kꂽ2̃xNg̓:  ̏ꍇ2̃xNg͔ΕĂB
			// Forward:

			if (vDot2 < 0)
			{
				͊p = -͊p;
			}
		}


		/// <summary>
		/// {Ch\ݒ2 ({Chp[^ݒ)
		/// </summary>
		public void \ݒ{Ch2(
									float ʎp,
									float len,

									float len,

									float \px, // xŎw
									float ōx,
									int HPmax
									)
		{
			Boidsʎp = MathHelper.ToRadians(ʎp);	// ͈͂̊px (ΏۂƂ͈)

			Boidslen = len;						// ΏۂƂȂ鋗 W:8

			Boidslen = len;  // ΏۂƂȂ鋗(len 琮len͈̔͂ł͑xAŋunitɍ킹)

			// ----------------------------------------------
			// 1t[ɉ]\Ȋpx
			m_\pxrad = MathHelper.ToRadians(\px);     // unit]\px(rad)

			m_ōx = ōx;
			m_Œᑬx = (m_ōx / 100f) * 50f;     // ōx50%

			m_x = (m_ōx / 100f) * 0.5f;  // ōx 0.5%
			m_x = (m_ōx / 100f) * 1.0f;  // ōx 1%

			// ----------------------------------------------
			// 1t[Ɉړ\ȋ(_̑x)
			m_x = m_Œᑬx;

			// ----------------------------------------------
			// GAME
			m_HPmax = HPmax;	// qbg|Cg ől 
			m_HP = HPmax;	// qbg|Cg 0Ōj 

			bՓ = false;
		}


		/// <summary>
		/// {Ch̐i (+-1%͈̔͂Ńp[^ωB)
		/// </summary>
		public void Boidsi()
		{
			Boids++;

			//V[hlw肵ȂƎԂɉČ肳̃V[hlgp
			System.Random r = new System.Random();

			// 2̈̊Ԃ̗Ԃ
			int x;

            // ̕ 99-101 (+-1%)
            int min =  99;
            int max = 102;

            // ̕ 96-104 (+-4%)
            min =  96;
            max = 105;

            x = r.Next(min, max);
            Boidsʎp = (Boidsʎp / 100f) * x;

            x = r.Next(min, max);
            Boidslen = (Boidslen / 100f) * x;

            x = r.Next(min, max);
            Boidslen = (Boidslen / 100f) * x;

			// ----------------------------------------------
			// 1t[ɉ]\Ȋpx
            x = r.Next(min, max);
            m_\pxrad = (m_\pxrad / 100f) * x;     // unit]\px(rad)


			// 1t[̈ړ
            x = r.Next(min, max);

            m_ōx = (m_ōx / 100f) * x;

			m_Œᑬx = (m_ōx / 100f) * 50f;     // ōx50%

			m_x = (m_ōx / 100f) * 0.5f;  // ōx 0.5%
			m_x = (m_ōx / 100f) * 1.0f;  // ōx 1%
		}


	}


	// ==================================================================================
	// ==================================================================================
	// :heightAӂ̏dS̋:rAFw
	// pos:dS̍2/1posƂB
	// Op tetrahedron (4ʑ)
	class Boid4ʑ : BoidModelTool
	{
		VertexDeclaration v錾 = null;         // Declaration : 錾
		VertexPositionNormalColor[] Vertices;   // Vertices:_ ({)
		VertexBuffer vobt@;      // Vertex buffer to define a triangle.

		// --------------------------------------
        public Boid4ʑ() { }


        // --------------------------------------
		/// <summary>
		/// :heightAӂ̏dS̋:rAFw
		/// </summary>
		/// <param name="graphics"></param>
		/// <param name="height"></param>
		/// <param name="r"></param>
		/// <param name="Col"></param>
		/// <param name="Col2"></param>
		public void Initialize(GraphicsDeviceManager graphics, float height, float r, Color Col, Color Col2)
		{
			// Col :{̂̐F
			// Col2:ӂ̐F

			int iVsize = 12;  // z

			v錾     = new VertexDeclaration(graphics.GraphicsDevice, VertexPositionNormalColor.VertexElements);
			vobt@ = new VertexBuffer(graphics.GraphicsDevice, typeof(VertexPositionNormalColor), iVsize, BufferUsage.WriteOnly);
			Vertices  = new VertexPositionNormalColor[iVsize];   // eNX`

			// :heightAӂ̏dS̋:rAFw
			// pos:dS̍2/1posƂB

			float h = height / 2f;

			// --------------------------------------------------------

			Vector2 v2 = new Vector2(0, r);
			Vector2 v2a = Vector2.Zero;

			Matrix m = Matrix.CreateRotationZ(((float)MathHelper.Pi * 2) / 3);
			v2a = Vector2.Transform(v2, m);  // MatrixɂVector2̃gXtH[(])

			Vector2 v2b = new Vector2(-v2a.X, v2a.Y);

			// --------------------------------------------------------
			Vector3 p0 = new Vector3(0, h, 0);  // _
			Vector3 p2 = new Vector3(0, -h, r);    // 1
			Vector3 p1 = new Vector3(v2a.X, -h, v2a.Y); // 2
			Vector3 p3 = new Vector3(-v2a.X, -h, v2a.Y);  // 3

			// --------------------------------------------------------
			// y+𒸓_ƂOpz+𒸓_Ƃ悤ɉ]

			m = Matrix.CreateRotationX((float)MathHelper.Pi / 2);

			// MatrixɂVector3̃gXtH[(])
			p0 = Vector3.Transform(p0, m);
			p2 = Vector3.Transform(p2, m);
			p1 = Vector3.Transform(p1, m);
			p3 = Vector3.Transform(p3, m);

			// --------------------------------------------------------

			Vector3 Normal = Vector3.Zero;

			// (v)ɐݒ

			// O
            Normal = NormalFromTriangle_@ݒ(p0,p3,p1);
            Vertices[0] = new VertexPositionNormalColor(p0, Normal, Col);
			Vertices[1] = new VertexPositionNormalColor(p3, Normal, Col);
			Vertices[2] = new VertexPositionNormalColor(p1, Normal, Col);

			// 
            Normal = NormalFromTriangle_@ݒ(p1, p2, p0);
            Vertices[3] = new VertexPositionNormalColor(p1, Normal, Col);
			Vertices[4] = new VertexPositionNormalColor(p2, Normal, Col);
			Vertices[5] = new VertexPositionNormalColor(p0, Normal, Col);


			//  = ӂ̐Fw肷邱ƂoB
            Normal = NormalFromTriangle_@ݒ(p3, p2, p1);
            Vertices[6] = new VertexPositionNormalColor(p3, Normal, Col2);
			Vertices[7] = new VertexPositionNormalColor(p2, Normal, Col2);
			Vertices[8] = new VertexPositionNormalColor(p1, Normal, Col2);

			// E
            Normal = NormalFromTriangle_@ݒ(p2, p3, p0);
            Vertices[ 9] = new VertexPositionNormalColor(p2, Normal, Col);
			Vertices[10] = new VertexPositionNormalColor(p3, Normal, Col);
			Vertices[11] = new VertexPositionNormalColor(p0, Normal, Col);

            vobt@.SetData<VertexPositionNormalColor>(Vertices);
		}



        // --------------------------------------
        public void Draw(GraphicsDeviceManager graphics )
        {
            graphics.GraphicsDevice.VertexDeclaration = this.v錾;
            graphics.GraphicsDevice.Vertices[0].SetSource(vobt@, 0, VertexPositionNormalColor.Size);

            F_Game.BoidsEffect.effect.Begin();
            foreach (EffectPass pass in F_Game.BoidsEffect.effect.CurrentTechnique.Passes)
            {
                pass.Begin();

                graphics.GraphicsDevice.DrawPrimitives(PrimitiveType.TriangleList, 0, 4);

                pass.End();
            }
            F_Game.BoidsEffect.effect.End();

        } // Draw end


	}





    // ==================================================================================
    // ==================================================================================
    // 8ʑ octahedron
    class Boid8ʑ : BoidModelTool
    {
        VertexDeclaration v錾 = null;         // Declaration : 錾

        VertexPositionNormalColor[] Vertices;   // Vertices:_ ({)

        VertexBuffer vobt@;      // Vertex buffer to define a triangle.

        // --------------------------------------
        public Boid8ʑ()
        {
        }


        // :h(y)A:r(x,z)A(dS̋)AFw
        public void Initialize(GraphicsDeviceManager graphics, float h, float r, Color C1, Color C2)
        {
            // C1:y̐F
            // C2:y̐F

            int iVsize = 24;  // z(3*8)

            v錾       = new VertexDeclaration(graphics.GraphicsDevice, VertexPositionNormalColor.VertexElements);
            vobt@   = new VertexBuffer(graphics.GraphicsDevice, typeof(VertexPositionNormalColor), iVsize, BufferUsage.WriteOnly);
            Vertices    = new VertexPositionNormalColor[iVsize];   // eNX`

            
            Vector3 p0 = new Vector3(+r, 0, 0);  // +x
            Vector3 p1 = new Vector3(-r, 0, 0);  // -x

            // ()
            Vector3 p2 = new Vector3(0, +h, 0);  // +y
            p2 = new Vector3(0, +h * 0.65f, 0);  // +y OZ(H^)

            Vector3 p3 = new Vector3(0, -h, 0);  // -y

            Vector3 p4 = new Vector3(0, 0, +r);  // +z
            Vector3 p5 = new Vector3(0, 0, -r);  // -z


            // --------------------------------------------------------
            // y+𒸓_ƂOpz+𒸓_Ƃ悤ɉ]

            Matrix m = Matrix.CreateRotationX((float)MathHelper.Pi / 2);

            // MatrixɂVector3̃gXtH[(])
            p0 = Vector3.Transform(p0, m);
            p1 = Vector3.Transform(p1, m);
            p2 = Vector3.Transform(p2, m);
            p3 = Vector3.Transform(p3, m);
            p4 = Vector3.Transform(p4, m);
            p5 = Vector3.Transform(p5, m);


            int os = 0;   // offset

            Vector3 Normal = Vector3.Zero;

            // (v)ɐݒ


            Normal = NormalFromTriangle_@ݒ(p2, p4, p0);

            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p2, p1, p4);

            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C2);

            Normal = NormalFromTriangle_@ݒ(p2, p5, p1);

            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p2, p0, p5);

            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C2);

// -------------------------
            Normal = NormalFromTriangle_@ݒ(p3, p0, p4);

            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p3, p4, p1);

            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C2);

            Normal = NormalFromTriangle_@ݒ(p3, p1, p5);

            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p3, p5, p0);

            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C2);

            vobt@.SetData<VertexPositionNormalColor>(Vertices);
        }


        // --------------------------------------
        public void Draw(GraphicsDeviceManager graphics)
        {
            graphics.GraphicsDevice.VertexDeclaration = this.v錾;
            graphics.GraphicsDevice.Vertices[0].SetSource(vobt@, 0, VertexPositionNormalColor.Size);

            F_Game.BoidsEffect.effect.Begin();
            foreach (EffectPass pass in F_Game.BoidsEffect.effect.CurrentTechnique.Passes)
            {
                pass.Begin();

                graphics.GraphicsDevice.DrawPrimitives(PrimitiveType.TriangleList, 0, 8);

                pass.End();
            }
            F_Game.BoidsEffect.effect.End();

        } // Draw end

    }


    // ==================================================================================
    // ==================================================================================
    // 20ʑ  icosahedron
    class Boid20ʑ : BoidModelTool
    {
        VertexDeclaration           v錾 = null;   // Declaration : 錾
        VertexPositionNormalColor[] Vertices;       // Vertices:_ ({)
        VertexBuffer                vobt@;      // Vertex buffer to define a triangle.

        // --------------------------------------
        public Boid20ʑ()
        {}


        // a:rAFw
        public void Initialize(GraphicsDeviceManager graphics, float r, Color C1, Color C2)
        {
            // C1:y̐F
            // C2:y̐F

            int iVsize = 60;  // z(3*20)

            v錾 = new VertexDeclaration(graphics.GraphicsDevice, VertexPositionNormalColor.VertexElements);
            vobt@ = new VertexBuffer(graphics.GraphicsDevice, typeof(VertexPositionNormalColor), iVsize, BufferUsage.WriteOnly);
            Vertices = new VertexPositionNormalColor[iVsize];   // eNX`


            float t = (float)( (1 + Math.Sqrt(5)) / 2);

            t = t * r;

			// QOʑ̂̒_12 222
            Vector3 p0  = new Vector3( 0,  t,  r);
            Vector3 p1  = new Vector3( 0,  t, -r);
            Vector3 p2  = new Vector3( 0, -t,  r);
            Vector3 p3  = new Vector3( 0, -t, -r);
            Vector3 p4  = new Vector3( r,  0,  t);
            Vector3 p5  = new Vector3( r,  0, -t);
            Vector3 p6  = new Vector3(-r,  0,  t);
            Vector3 p7  = new Vector3(-r,  0, -t);
            Vector3 p8  = new Vector3( t,  r,  0);
            Vector3 p9  = new Vector3( t, -r,  0);
            Vector3 p10 = new Vector3(-t,  r,  0);
            Vector3 p11 = new Vector3(-t, -r,  0);


            // --------------------------------------------------------
            // y+𒸓_ƂOpz+𒸓_Ƃ悤ɉ]
            Matrix m = Matrix.Identity;
//          m = Matrix.CreateRotationX((float)Math.Atan2(r, t)); // yɒ_
            m = Matrix.CreateRotationX((float)Math.Atan2(t, r)); // zɒ_

            // MatrixɂVector3̃gXtH[(])
            p0 = Vector3.Transform(p0, m);
            p1 = Vector3.Transform(p1, m);
            p2 = Vector3.Transform(p2, m);
            p3 = Vector3.Transform(p3, m);
            p4 = Vector3.Transform(p4, m);
            p5 = Vector3.Transform(p5, m);

            p6 = Vector3.Transform(p6, m);
            p7 = Vector3.Transform(p7, m);
            p8 = Vector3.Transform(p8, m);
            p9 = Vector3.Transform(p9, m);
            p10 = Vector3.Transform(p10, m);
            p11 = Vector3.Transform(p11, m);


            int os = 0;   // offset

            Vector3 Normal = Vector3.Zero;

            // (v)ɐݒ

            Normal = NormalFromTriangle_@ݒ(p0, p6, p4);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p6, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p0, p4, p8);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p8, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p0, p8, p1);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p8, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p0, p1, p10);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p10, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p0, p10, p6);
            Vertices[os++] = new VertexPositionNormalColor(p0, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p10, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p6, Normal, C1);
                
            // -------------------------------------------------------------------------------
            Normal = NormalFromTriangle_@ݒ(p3, p9, p2);
            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p9, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p3, p2, p11);
            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p11, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p3, p11, p7);
            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p11, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p7, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p3, p7, p5);
            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p7, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p3, p5, p9);
            Vertices[os++] = new VertexPositionNormalColor(p3, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p9, Normal, C1);

            // -------------------------------------------------------------------------------

            // ̖ʂ݂ɐFςB
            Normal = NormalFromTriangle_@ݒ(p1, p5, p7);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p7, Normal, C2);

            Normal = NormalFromTriangle_@ݒ(p10, p7, p11);
            Vertices[os++] = new VertexPositionNormalColor(p10, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p7, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p11, Normal, C2);

            Normal = NormalFromTriangle_@ݒ(p6, p11, p2);
            Vertices[os++] = new VertexPositionNormalColor(p6, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p11, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C2);

            Normal = NormalFromTriangle_@ݒ(p4, p2, p9);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p9, Normal, C2);

            Normal = NormalFromTriangle_@ݒ(p8, p9, p5);
            Vertices[os++] = new VertexPositionNormalColor(p8, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p9, Normal, C2);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C2);

            // -------------------------------------------------------------------------------
            Normal = NormalFromTriangle_@ݒ(p2, p4, p6);
            Vertices[os++] = new VertexPositionNormalColor(p2, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p6, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p9, p8, p4);
            Vertices[os++] = new VertexPositionNormalColor(p9, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p8, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p4, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p5, p1, p8);
            Vertices[os++] = new VertexPositionNormalColor(p5, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p8, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p7, p10, p1);
            Vertices[os++] = new VertexPositionNormalColor(p7, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p10, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p1, Normal, C1);

            Normal = NormalFromTriangle_@ݒ(p11, p6, p10);
            Vertices[os++] = new VertexPositionNormalColor(p11, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p6, Normal, C1);
            Vertices[os++] = new VertexPositionNormalColor(p10, Normal, C1);

            vobt@.SetData<VertexPositionNormalColor>(Vertices);
        }


        // --------------------------------------
        public void Draw(GraphicsDeviceManager graphics)
        {
            graphics.GraphicsDevice.VertexDeclaration = this.v錾;
            graphics.GraphicsDevice.Vertices[0].SetSource(vobt@, 0, VertexPositionNormalColor.Size);

            F_Game.BoidsEffect.effect.Begin();
            foreach (EffectPass pass in F_Game.BoidsEffect.effect.CurrentTechnique.Passes)
            {
                pass.Begin();

                graphics.GraphicsDevice.DrawPrimitives(PrimitiveType.TriangleList, 0, 20);

                pass.End();
            }
            F_Game.BoidsEffect.effect.End();

        } // Draw end

    }



	// ========================================================================
	// JX^_VertexPositionNormalColor gp
	// Simple Program 3 http://www.gameprojects.com/project/?id=942a7cc022
    class BoidF : BoidModelTool
	{
		VertexDeclaration decl__錾;      // _錾
		VertexPositionNormalColor[] Vertices__z;  // Vertices:_ ({)
		VertexBuffer VB__obt@;

		BoundingSphere ;

		// --------------------------------------
		public BoidF()
		{
		}


		// ԓ\ׂ͂ɉ~6 + (4*x)ƂB
		// 6,10,14,18,22,26,30,...122...254
		// |SɐFςB
		public void Initialize(GraphicsDeviceManager graphics, int ~, float a)
		{
			// cube{
			decl__錾 = new VertexDeclaration(graphics.GraphicsDevice, VertexPositionNormalColor.VertexElements);

			this. = new BoundingSphere(Vector3.Zero, a);

			int segment_~_Count = ~; // ~ݒ

			// ~͈̓`FbN
			if (~ < 4)
			{
				segment_~_Count = 4; // ŏ~ݒ
			}
			if (~ > 1024)
			{
				segment_~_Count = 1024; // ő~ݒ
			}


			int totalRows_~ = segment_~_Count / 2 - 1; //The number of rows in the sphere, not counting top and bottom verts

			int totalVerts = totalRows_~ * segment_~_Count + 2;
			int totalFaces = totalRows_~ * segment_~_Count * 2;   // (|S)                       


			Vertices__z = new VertexPositionNormalColor[totalFaces * 3]; // _ = |S * 3


			this.oVertices__z = new Vector3[totalVerts];

			int ix, jx, kx;		// Index variables
			int na, nb, nc, nd; // Temporary integers

			int vertCount = 0;	// Counters for the number of vertices

			float a, b, c;					//Temporary floats
			float alt, secRad, secAng;		//Altitude, radial secant, angular secant

			float delta = 2.0f * MathHelper.Pi / segment_~_Count;
			float delta2 = delta;
			float startAngle = 0;

			int vc = 0; // _JEg

			Color wkColor = Color.Red;
			Vector3 wkNormal;

			// -------------------------------------
			// _

			//  _ Top vertex 
			this.oVertices__z[vertCount] = new Vector3(0, 0, 1 * a);

			vertCount++;


			// -------------------------------------
			//  _ Middle vertices 
			alt = delta;

			for (ix = 1; ix <= totalRows_~; ix++)
			{
				a = (float)Math.Cos(alt);

				secRad = (float)Math.Sin(alt);
				secAng = startAngle;

				for (jx = 0; jx < segment_~_Count; ++jx)
				{
					b = (float)Math.Cos(secAng) * secRad;
					c = (float)Math.Sin(secAng) * secRad;

					this.oVertices__z[vertCount] = new Vector3(b * a, c * a, a * a);

					secAng += delta2;
					vertCount++;
				}

				alt += delta;
			}


			// -------------------------------------
			//  _ Bottom vertex
			this.oVertices__z[vertCount] = new Vector3(0, 0, -1 * a);

			vertCount++;


			// -------------------------------------
			// -------------------------------------
			//  @

			// Now make faces 	
			//  @ Make top conic cap (~ )
			for (ix = 1; ix <= segment_~_Count; ++ix)
			{
				nc = (ix == segment_~_Count) ? 1 : ix + 1;

				// ?:Zq
				/*
				if(ix == segment_~_Count)
				{
					nc = 1;
				}
				else
				{
					nc = ix +1;
				}
				*/

				// ʐݒ(z̓Yݒ)
				this.Faces_.Set(0, ix, nc);

                wkNormal = NormalFromTriangle_@ݒ(
						this.oVertices__z[this.Faces_.A],
						this.oVertices__z[this.Faces_.B],
						this.oVertices__z[this.Faces_.C] );

				wkColor = Color.Blue;

				//  F
				if ((ix % 2) == 0)
				{
					wkColor = Color.White;
				}

				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

				face__Count++;
			}

			//  @ Make midsection
			for (ix = 1; ix < totalRows_~; ++ix)
			{
				jx = (ix - 1) * segment_~_Count + 1;

				for (kx = 0; kx < segment_~_Count; ++kx)
				{
					// lp(|S2)
					na = jx + kx;
					nb = na + segment_~_Count;

					nc = (kx == (segment_~_Count - 1)) ? jx + segment_~_Count : nb + 1;
					nd = (kx == (segment_~_Count - 1)) ? jx : na + 1;

					// -------------------------------------------------
					// @߂邽߂̖ʐݒ (1) a-b-c
					this.Faces_.Set(na, nb, nc);

                    wkNormal = NormalFromTriangle_@ݒ(
							this.oVertices__z[this.Faces_.A],
							this.oVertices__z[this.Faces_.B],
							this.oVertices__z[this.Faces_.C] );

					wkColor = Color.White;
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

					face__Count++;

					// -------------------------------------------------
					// @߂邽߂̖ʐݒ (2) a-c-d
					this.Faces_.Set(na, nc, nd);

                    wkNormal = NormalFromTriangle_@ݒ(
							this.oVertices__z[this.Faces_.A],
							this.oVertices__z[this.Faces_.B],
							this.oVertices__z[this.Faces_.C] );



					// ԓݒ
					if ((totalRows_~ / 2) == ix)
					{
						wkColor = Color.Red;    // ԓ\
					}
					else
					{
						wkColor = Color.Gray;
					}

					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

					face__Count++;
				}
			}

			//  @ Make bottom conic cap (~ )
			na = totalVerts - 1;
			jx = (totalRows_~ - 1) * segment_~_Count + 1;

			for (ix = 0; ix < segment_~_Count; ++ix)
			{
				nc = ix + jx;
				nb = (ix == segment_~_Count - 1) ? jx : nc + 1;

				this.Faces_.Set(na, nb, nc);

                wkNormal = NormalFromTriangle_@ݒ(
                        this.oVertices__z[this.Faces_.A],
						this.oVertices__z[this.Faces_.B],
						this.oVertices__z[this.Faces_.C] );

				wkColor = Color.Green;

				//  F
				if ((ix % 2) == 1)
				{
					wkColor = Color.White;
				}

				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

				face__Count++;
			}


			VB__obt@ = new VertexBuffer(
				graphics.GraphicsDevice,
				VertexPositionNormalColor.Size * Vertices__z.Length,
				BufferUsage.None);


			VB__obt@.SetData<VertexPositionNormalColor>(Vertices__z);
		}


		// ԓ\ׂ͂ɉ~6 + (4*x)ƂB
		// 6,10,14,18,22,26,30,...122...254
		// Initialize2:FύXAlp`ɐFςB
		// k:(0,1,0) (0,-1,0)
		public void Initialize2(GraphicsDeviceManager graphics, int ~, float a, Color Col{, Color Col, Color Colԓ)
		{
			// cube{
			decl__錾 = new VertexDeclaration(graphics.GraphicsDevice, VertexPositionNormalColor.VertexElements);

			this. = new BoundingSphere(Vector3.Zero, a);

			int segment_~_Count = ~; // ~ݒ

			// ~͈̓`FbN
			if (~ < 4)
			{
				segment_~_Count = 4; // ŏ~ݒ
			}
			if (~ > 1024)
			{
				segment_~_Count = 1024; // ő~ݒ
			}


			int totalRows_~ = segment_~_Count / 2 - 1; //The number of rows in the sphere, not counting top and bottom verts

			int totalVerts = totalRows_~ * segment_~_Count + 2;
			int totalFaces = totalRows_~ * segment_~_Count * 2;   // (|S)                       

			Vertices__z = new VertexPositionNormalColor[totalFaces * 3]; // _ = |S * 3


			this.oVertices__z = new Vector3[totalVerts];

			int ix, jx, kx;		// Index variables
			int na, nb, nc, nd; // Temporary integers

			int vertCount = 0;	// Counters for the number of vertices

			float a, b, c;					//Temporary floats
			float alt, secRad, secAng;		//Altitude, radial secant, angular secant

			float delta = 2.0f * MathHelper.Pi / segment_~_Count;
			float delta2 = delta;
			float startAngle = 0;

			int vc = 0; // _JEg

			Color wkColor = Color.Red;
			Vector3 wkNormal;

			Color F1 = Color.White;
			Color F2 = Color.Gray;

            /*
            // Ŝ𓯂F 
			F1 = Col{;
			F2 = Col{;
             */

			// -------------------------------------
			// -------------------------------------
			// _

			//  _ Top vertex 
			this.oVertices__z[vertCount] = new Vector3(0, 1 * a, 0);

			vertCount++;


			// -------------------------------------
			//  _ Middle vertices 
			alt = delta;

			for (ix = 1; ix <= totalRows_~; ix++)
			{
				a = (float)Math.Cos(alt);

				secRad = (float)Math.Sin(alt);
				secAng = startAngle;

				for (jx = 0; jx < segment_~_Count; ++jx)
				{
					b = (float)Math.Cos(secAng) * secRad;
					c = (float)Math.Sin(secAng) * secRad;

					this.oVertices__z[vertCount] = new Vector3(b * a, a * a, c * a);

					secAng += delta2;
					vertCount++;
				}

				alt += delta;
			}


			// -------------------------------------
			//  _ Bottom vertex
			this.oVertices__z[vertCount] = new Vector3(0, -1 * a, 0);

			vertCount++;

            /*
			// 90] (ɂis)
			Matrix m = Matrix.CreateRotationX((float)Math.PI / 2f);
			for (int i = 0; i < this.oVertices__z.Length; i++)
			{
				this.oVertices__z[i] = Vector3.Transform(this.oVertices__z[i], m);
			}
            */


			// -------------------------------------
			// -------------------------------------
			//  @

			// Now make faces 	
			//  @ Make top conic cap (~ )
			for (ix = 1; ix <= segment_~_Count; ++ix)
			{
				nc = (ix == segment_~_Count) ? 1 : ix + 1;

				// ?:Zq
				/*
				if(ix == segment_~_Count)
				{
					nc = 1;
				}
				else
				{
					nc = ix +1;
				}
				*/

				// ʐݒ(z̓Yݒ)
				this.Faces_.Set(0, ix, nc);

                wkNormal = NormalFromTriangle_@ݒ(
                        this.oVertices__z[this.Faces_.A],
						this.oVertices__z[this.Faces_.B],
						this.oVertices__z[this.Faces_.C] );

				wkColor = Color.Green;
				wkColor = Col{;

				// S悤ɁA1{̂ݐFςB
				/*
								if(1 == ix)
								{
									wkColor = F1;
								}
				*/

				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

				face__Count++;
			}



			// ==================================================================================
			//  @ Make midsection
			for (ix = 1; ix < totalRows_~; ++ix)
			{
				jx = (ix - 1) * segment_~_Count + 1;

				for (kx = 0; kx < segment_~_Count; ++kx)
				{

					// ------------------------------------
					// Fݒ
					if (ix % 2 == 1)
					{
						if (kx % 2 == 1)
						{
							wkColor = F1;

							// ԓݒ
							if ((totalRows_~ / 2) == ix)
							{
								wkColor = Colԓ;    // ԓ\
							}
						}
						else
						{
							wkColor = F2;
						}
					}
					else
					{
						if (kx % 2 == 1)
						{
							wkColor = F2;

							// ԓݒ
							if ((totalRows_~ / 2) == ix)
							{
								wkColor = Colԓ;    // ԓ\
							}
						}
						else
						{
							wkColor = F1;
						}
					}




					// lp(|S2)
					na = jx + kx;
					nb = na + segment_~_Count;

					nc = (kx == (segment_~_Count - 1)) ? jx + segment_~_Count : nb + 1;
					nd = (kx == (segment_~_Count - 1)) ? jx : na + 1;

					// -------------------------------------------------
					// @߂邽߂̖ʐݒ (1) a-b-c
					this.Faces_.Set(na, nb, nc);

                    wkNormal = NormalFromTriangle_@ݒ(
                            this.oVertices__z[this.Faces_.A],
							this.oVertices__z[this.Faces_.B],
							this.oVertices__z[this.Faces_.C] );

					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

					face__Count++;

					// -------------------------------------------------
					// @߂邽߂̖ʐݒ (2) a-c-d
					this.Faces_.Set(na, nc, nd);

                    wkNormal = NormalFromTriangle_@ݒ(
                            this.oVertices__z[this.Faces_.A],
							this.oVertices__z[this.Faces_.B],
							this.oVertices__z[this.Faces_.C] );

					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
					Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

					face__Count++;
				}
			}





			//  @ Make bottom conic cap (~ )
			na = totalVerts - 1;
			jx = (totalRows_~ - 1) * segment_~_Count + 1;

			for (ix = 0; ix < segment_~_Count; ++ix)
			{
				nc = ix + jx;
				nb = (ix == segment_~_Count - 1) ? jx : nc + 1;

				this.Faces_.Set(na, nb, nc);

                wkNormal = NormalFromTriangle_@ݒ(
                        this.oVertices__z[this.Faces_.A],
						this.oVertices__z[this.Faces_.B],
						this.oVertices__z[this.Faces_.C] );

				wkColor = Color.Blue;
				wkColor = Col; // Fݒ

				// S悤ɁA1{̂ݐFςB
				/*
								if (1 == ix)
								{
									wkColor = F2;
								}
				*/

				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.A], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.B], wkNormal, wkColor);
				Vertices__z[vc++] = new VertexPositionNormalColor(this.oVertices__z[this.Faces_.C], wkNormal, wkColor);

				face__Count++;
			}


			VB__obt@ = new VertexBuffer(
				graphics.GraphicsDevice,
				VertexPositionNormalColor.Size * Vertices__z.Length,
				BufferUsage.None);

			VB__obt@.SetData<VertexPositionNormalColor>(Vertices__z);
		}




		// --------------------------------------
		public void Draw(GraphicsDeviceManager graphics)
		{
            graphics.GraphicsDevice.RenderState.CullMode = CullMode.None;	// CullClockwiseFace:{CullMode ( E(v)̖ʂJOBʂ̗`)

			graphics.GraphicsDevice.VertexDeclaration = decl__錾;
			graphics.GraphicsDevice.Vertices[0].SetSource(VB__obt@, 0, VertexPositionNormalColor.Size);

            F_Game.BoidsEffect.effect.Begin();
            foreach (EffectPass pass in F_Game.BoidsEffect.effect.CurrentTechnique.Passes)
			{
				pass.Begin();

				graphics.GraphicsDevice.DrawPrimitives(
					PrimitiveType.TriangleList,
					0,
					this.face__Count  // \|S
				);

				/*
                primitiveType
                    _Ov~eBǔ^ɂĐ܂B
                startVertex
                    ǂݍލŏ̒_̃CfbNXB 擪 startVertex, _obt@̊Oǂݎ́A_B
                primitiveCount
                    _Ov~eBu̐łB mFłv~eBu̍ő吔`FbN܂B MaxPrimitiveCount. ܂ primitiveCount v~eBu ^CvɂČ܂ƃv~eBu̐łB ꍇAXg 2 ̒_͂ꂼv~eBułB ꍇAgCAO Xg 3 ̒_͂ꂼv~eBułB
                */

				pass.End();
			}
            F_Game.BoidsEffect.effect.End();

            graphics.GraphicsDevice.RenderState.CullMode = CullMode.CullClockwiseFace;	// CullClockwiseFace:{CullMode ( E(v)̖ʂJOBʂ̗`)
		}


		// ========================

		public Vector3[] oVertices__z;

		public Face Faces_;

		public int face__Count = 0;  // (|S)̐Counters for the number of faces 

	}




    // \f {NX
    class BoidModelTool
    {
        public BoidModelTool() { }

        /// <summary>
        /// @ݒ 
        /// </summary>
        /// <param name="p0"></param>
        /// <param name="p1"></param>
        /// <param name="p2"></param>
        /// <returns></returns>
        public Vector3 NormalFromTriangle_@ݒ(Vector3 p0, Vector3 p1, Vector3 p2)
        {
            // Computes a normal from three triangle vertices
            Vector3 v0 = p1 - p2;
            Vector3 v1 = p0 - p2;

            Vector3 normal = Vector3.Cross(v0, v1);

            normal.Normalize();

            return normal;
        }
    }


}
