// O[oϐ

//uniform extern float4x4 WorldViewProj : WORLDVIEWPROJECTION;
uniform extern float4x4 g_WorldViewProj;	// OՁAՓː p

uniform extern float4x4	g_World;
uniform extern float4x4	g_World_inv;

uniform extern float4x4	g_ViewProj;		// {ChA p

uniform extern float4	g_Light_dir;

uniform extern float4	g_color0;	// F + gUːF
uniform extern float4	g_color1;	// ArGg

uniform extern float	g_Len;		// Jƌ_̋



struct VS_INPUT
{
    float4 Pos 		: POSITION;
    float4 color    : COLOR0;
};

struct VS_OUTPUT
{
    float4 Pos 		: POSITION;
    float4 color    : COLOR0;
};


// ==================================================================
// sNZVF[_ ()
void PixelShader(inout float4 color : COLOR0 ){}


// ==================================================================
// _VF[_
VS_OUTPUT BasicVS(
		float4 in_pos   :POSITION,
        float3 in_normal:NORMAL,
		float4 in_Color :COLOR0 )
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    // Wϊ
	Out.Pos = mul( in_pos, mul( g_World, g_ViewProj ) );

    // _̐FvZ
    float4 local_Light;
    float4 wk_color;

    local_Light = normalize( mul( g_Light_dir, g_World_inv ) );

    wk_color = saturate( g_color0 * max( 0, dot( local_Light, -in_normal ) ) );	// F + gUːF
	wk_color = in_Color * wk_color;					// _Fgp
	wk_color = wk_color + ( in_Color * g_color1 );	// ArGg

    Out.color = wk_color;

    return Out;

	// saturate(x) : x  [0, 1] ͈̔͂ɐ
	// max(a,b) :  a  b ̂̑傫̒lI
	// dot(a, b): 2 ̃xNg a  b ̓ςԂ܂B 
}




// ==================================================================
// eNjbN錾
// {Ch\p eNX`ACgLA_Fgp
technique BasicTech
{
    pass P0
    {
        vertexShader = compile vs_2_0 BasicVS();
		pixelShader  = compile ps_1_1 PixelShader();
    }
}





// OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
// OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
// OՁAՓː p

VS_OUTPUT Transform(
    float4 Pos   : POSITION, 
    float4 Color : COLOR0 )
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    Out.Pos = mul(Pos, g_WorldViewProj);

    Out.color    = Color;
    return Out;
}


// OՁAՓː p
technique TransformTech
{
    pass P0
    {
        vertexShader = compile vs_2_0 Transform();
        pixelShader  = compile ps_1_1 PixelShader();
    }
}









// OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
// OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

// xna̕\p O/ʂŐFς
VS_OUTPUT SphereVS( VS_INPUT Input )
{
    VS_OUTPUT Output;

    // _ʒuˉeԂɃgXtH[
//	Output.Pos = mul( Input.Pos, WorldViewProj );
	Output.Pos = mul( Input.Pos, g_ViewProj );

	if( Output.Pos.z > g_Len )	// g_Len = J̉sʒu
	{
		Output.color.r = Input.color.r * 0.7f;
		Output.color.g = Input.color.g * 0.7f;
		Output.color.b = Input.color.b * 0.7f;
/*
		Output.color.r = 1;
		Output.color.g = 0;
		Output.color.b = 1;
*/
	}
	else
	{
		Output.color = Input.color;
	}

    return Output;
}


//--------------------------------------------------------------------------------------
// Techniques
//--------------------------------------------------------------------------------------
// p
technique RenderSphereTech
{
    pass P0
    {          
		vertexShader = compile vs_2_0 SphereVS();
		pixelShader  = compile ps_1_1 PixelShader();
    }
}

