﻿using System;

using System.IO;
using System.Runtime.Serialization.Formatters.Binary;


namespace WindowsGame1
{
	[Serializable()]
	public class チーム情報
	{
		public int   iボイド数A羊 = 0;
		public float f視角A羊 = 0f;
		public float f分離距離A羊 = 0f;
		public float f整列距離A羊 = 0f;
		public float f角度A羊 = 0f;
		public float f速度A羊 = 0f;

		public int   iボイド数A狼 = 0;
		public float f視角A狼 = 0f;
		public float f分離距離A狼 = 0f;
		public float f整列距離A狼 = 0f;
		public float f角度A狼 = 0f;
		public float f速度A狼 = 0f;

		public int   iボイド数A犬 = 0;
		public float f視角A犬 = 0f;
		public float f分離距離A犬 = 0f;
		public float f整列距離A犬 = 0f;
		public float f角度A犬 = 0f;
		public float f速度A犬 = 0f;

		public int   iボイド数B羊 = 0;
		public float f視角B羊 = 0f;
		public float f分離距離B羊 = 0f;
		public float f整列距離B羊 = 0f;
		public float f角度B羊 = 0f;
		public float f速度B羊 = 0f;

		public int   iボイド数B狼 = 0;
		public float f視角B狼 = 0f;
		public float f分離距離B狼 = 0f;
		public float f整列距離B狼 = 0f;
		public float f角度B狼 = 0f;
		public float f速度B狼 = 0f;

		public int   iボイド数B犬 = 0;
		public float f視角B犬 = 0f;
		public float f分離距離B犬 = 0f;
		public float f整列距離B犬 = 0f;
		public float f角度B犬 = 0f;
		public float f速度B犬 = 0f;


		public チーム情報()
		{
		}


		public void デフォルト値マルチコア()
		{

/*
					109f,	// 方位視角
					8f,		// 分離len
					15f,	// 整列len
					0.74f,	// 可能角度
					0.65f,	// 最高速度
					100		// HPmax
*/

			// ボイド数 1チーム 128の場合のボイドタイプ数 
			iボイド数A羊 = iボイド数B羊	= 104;
			f視角A羊 = f視角B羊			= 109f;
			f分離距離A羊 = f分離距離B羊 = 8f;
			f整列距離A羊 = f整列距離B羊 = 15f;
			f角度A羊 = f角度B羊			= 0.74f;
			f速度A羊 = f速度B羊			= 0.65f;

			iボイド数A狼 = iボイド数B狼 = 12;
			f視角A狼 = f視角B狼			= 109f;
			f分離距離A狼 = f分離距離B狼 = 8f;
			f整列距離A狼 = f整列距離B狼 = 15f;
			f角度A狼 = f角度B狼			= 0.74f;
			f速度A狼 = f速度B狼			= 0.65f;

			iボイド数A犬 = iボイド数B犬 = 12;
			f視角A犬 = f視角B犬			= 109f;
			f分離距離A犬 = f分離距離B犬 = 8f;
			f整列距離A犬 = f整列距離B犬 = 15f;
			f角度A犬 = f角度B犬			= 0.74f;
			f速度A犬 = f速度B犬			= 0.65f;
		}


		public void デフォルト値シングルコア()
		{

			/*
								109f,	// 方位視角
								8f,		// 分離len
								15f,	// 整列len
								0.74f,	// 可能角度
								0.65f,	// 最高速度
								100		// HPmax
			*/

			// ボイド数 1チーム 128の場合のボイドタイプ数 
			iボイド数A羊 = iボイド数B羊 = 40;
			f視角A羊 = f視角B羊 = 109f;
			f分離距離A羊 = f分離距離B羊 = 8f;
			f整列距離A羊 = f整列距離B羊 = 15f;
			f角度A羊 = f角度B羊 = 0.74f;
			f速度A羊 = f速度B羊 = 0.65f;

			iボイド数A狼 = iボイド数B狼 = 12;
			f視角A狼 = f視角B狼 = 109f;
			f分離距離A狼 = f分離距離B狼 = 8f;
			f整列距離A狼 = f整列距離B狼 = 15f;
			f角度A狼 = f角度B狼 = 0.74f;
			f速度A狼 = f速度B狼 = 0.65f;

			iボイド数A犬 = iボイド数B犬 = 12;
			f視角A犬 = f視角B犬 = 109f;
			f分離距離A犬 = f分離距離B犬 = 8f;
			f整列距離A犬 = f整列距離B犬 = 15f;
			f角度A犬 = f角度B犬 = 0.74f;
			f速度A犬 = f速度B犬 = 0.65f;
		}


		public int ボイド数A() { return (this.iボイド数A羊 + this.iボイド数A狼 + this.iボイド数A犬); }
		public int ボイド数B() { return (this.iボイド数B羊 + this.iボイド数B狼 + this.iボイド数B犬); }



		// 爆裂！Ｃ＃野郎 http://csharp.yaminabe.info/2006/08/post_1.html より
		// 注.コピーするクラスに [Serializable()] 属性を付ける。
		/// <summary>
		/// オブジェクトをディープコピーする。(汎用的なクラスのディープコピー)
		/// </summary>
		/// <param name="source">コピー元オブジェクトを指定します。</param>
		/// <returns>コピー先オブジェクトを返します。</returns>
		/// <remarks>このメソッドを使用するには、対象クラスが Serializable できることが前提となります。</remarks>
		public static object DeepClone(object source)
		{
			object target = null;
			using (MemoryStream stream = new MemoryStream())
			{
				// コピー元オブジェクトをシリアライズします。
				BinaryFormatter formatter = new BinaryFormatter();
				formatter.Serialize(stream, source);
				stream.Position = 0;

				// シリアライズデータをコピー先オブジェクトにデシリアライズします。
				target = formatter.Deserialize(stream);
			}
			return target;
		}




	}
}
